<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development - Daniel Seifert <support@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */
class d3_cfg_watermark_Main extends d3_cfg_mod_main
{

    protected $_sThisTemplate = 'd3_cfg_watermark_main.tpl';

    protected $_sModId = 'd3_watermark';

    protected $_sMenuItemTitle = 'd3mxwatermark';

    protected $_sMenuSubItemTitle = 'd3mxwatermark_settings';

    protected $_sWatermarkName = 'd3_watermark';

    protected $_aImageTypes = array("GIF" => IMAGETYPE_GIF, "JPG" => IMAGETYPE_JPEG, "PNG" => IMAGETYPE_PNG);

    protected $_sHelpLinkMLAdd = 'D3_WATERMARK_MAIN_HELPLINK';

    protected $_blFailUpload = false;

    protected $_aAllowExtension = array("gif", "jpg", "png");

    public function render()
    {
        //Fehler beim Upload?
        $this->addTplParam("isfailupload", $this->_blFailUpload);

        return parent::render();
    }

    public function save()
    {
        $this->_savePictures();

        parent::save();

        return;
    }

    protected function _savePictures()
    {

        $sFilename = $_FILES['imagefile']['name'];

        if (!empty($sFilename)) {
            /** @var d3filesystem $oFS */
            $oFS               = oxNew('d3filesystem');
            $aFile             = $oFS->splitFilename($sFilename);
            $sCompareExtension = strtolower($aFile['ext']);

            if (!in_array($sCompareExtension, $this->_aAllowExtension)) {
                $this->_blFailUpload = 11;

                return false;
            }

            $sFileName = $this->_sWatermarkName . substr($sFilename, strrpos($sFilename, '.'));
            $sDest     = $this->getConfig()->getImageDir(1) . $sFileName;
            if (@ copy($_FILES['imagefile']['tmp_name'], $sDest)) {
                if (move_uploaded_file($_FILES['imagefile']['tmp_name'], $sDest)) {
                    $sType = $this->_createWMIcon($sDest, $sFileName);

                    $this->d3GetSet()->setValue('sWaterMark_FileName', $sFileName);
                    $this->d3GetSet()->setValue('sWaterMark_FileType', $sType);
                }
            }
        }
    }

    /**
     * @param $sSourceImage
     * @param $sFileName
     *
     * @return mixed
     */
    protected function _createWMIcon($sSourceImage, $sFileName)
    {
        list($width, $height, $type) = getimagesize($sSourceImage);

        $pDestImage   = null;
        $pSourceImage = null;
        $iNewWidth    = 100;
        $iFactor      = $width / $iNewWidth;
        $iNewHeight   = round($height / $iFactor);

        switch ($type) {
            case ($this->_aImageTypes["GIF"]):
                $pSourceImage = imagecreatefromgif($sSourceImage);
                $pDestImage   = imagecreate($iNewWidth, $iNewHeight);
                break;
            case ($this->_aImageTypes["JPG"]):
                $pSourceImage = imagecreatefromjpeg($sSourceImage);
                $pDestImage   = imagecreatetruecolor($iNewWidth, $iNewHeight);
                break;
            case ($this->_aImageTypes["PNG"]):
                $pSourceImage = imagecreatefrompng($sSourceImage);
                $pDestImage   = imagecreatetruecolor($iNewWidth, $iNewHeight);
                break;
        }

        $sIcoFileName      = $this->_sWatermarkName . '_ico' . substr($sFileName, strrpos($sFileName, '.'));
        $sDestinationImage = $this->getConfig()->getImageDir(1) . $sIcoFileName;

        $imgWhite = imagecolorallocate($pDestImage, 255, 255, 255);
        imagefill($pDestImage, 0, 0, $imgWhite);
        imagecolortransparent($pDestImage, $imgWhite);

        if (imagecopyresized($pDestImage, $pSourceImage, 0, 0, 0, 0, $iNewWidth, $iNewHeight, $width, $height)) {
            switch ($type) {
                case ($this->_aImageTypes["GIF"]):
                    imagegif($pDestImage, $sDestinationImage);
                    break;
                case ($this->_aImageTypes["JPG"]):
                    imagejpeg($pDestImage, $sDestinationImage);
                    break;
                case ($this->_aImageTypes["PNG"]):
                    imagepng($pDestImage, $sDestinationImage);
                    break;
            }

            $this->d3GetSet()->setValue('sWaterMark_IcoFileName', $sIcoFileName);
        }

        return $type;
    }
}